#include 	<avr/io.h>
#include 	<avr/interrupt.h>
#include 	<avr/pgmspace.h>
#include 	<stdio.h>
#include 	<stdarg.h>
#include 	<string.h>
#include	<stdlib.h>

#include 	"menu.h"
#include	"key.h"
#include	"text.h"
#include 	"lcd.h"

#include 	"printf.h"
#include 	"serial.h"

extern uint8_t		refesh;
extern uint32_t 	long_key;
//--------------------------------------------------------------------------//
/*
step = menu list
msel = default = 1;
page = menu list / 4 
*/
void display_menu (const char* const ms[], uint8_t step, 
					                        uint8_t msel,
											uint8_t page)
											
{
	uint8_t	glcdInvert = 0;
	uint8_t len =0,i,y = 0;

	uint8_t tmp[MAXLENGHT+1];  // 10 maybe upper and lower char Thai language
	
	for (i = page; i < step + page; i++)
	{
			memset (tmp, ' ', sizeof tmp); 
			
			len = strlen (ms[i]);  		//use for english language
			
			memcpy (tmp, ms[i], len);
			
			if (MAXLENGHT  < sizeof tmp)
     			tmp[MAXLENGHT] = 0;	
			
			if (((msel + page) -1) == i)
					glcdInvert = 1;
			glcd_Printf (2, y,tmp,glcdInvert,BIG_FONT);
				glcdInvert = 0;
			y+=16;
	}
}

uint8_t menu (const char* const string[], uint8_t menuList)
{
	uint8_t ch, nRet = 1;
	uint8_t select 	 = 1;
	uint8_t page 	 = 0;
	
	
		display_menu (string, LINE_PAGE, select, page);

		while (nRet)
		{
			ch = get_key ();
			if (long_key != 0) long_key--;
			
			if (ch != 0)
			{
				//beep ();
				//printf ("\r\nCH = %02X",ch);
				switch (ch)
				{
					case DOWN		:	//slide down
										if (select < LINE_PAGE)
										{
											select++;
										}
										else
										{
											if (page < (menuList - LINE_PAGE))
											{
												page += 1;
											}
										}
										display_menu (string, LINE_PAGE, select, page);
										break;
										
					case UP	:			//slide up
										if (select > 1)
										{
											select--;
										}
										else
										{
											if (page > 0)
											{
												page -= 1;
											}
										}
										display_menu (string, LINE_PAGE, select, page);
										break;
					case ENT:
#ifdef 	DEBUG_MENU					
										printf ("\r\nEnt = %d",select + page);
#endif										
										nRet 	= 0;
										break;
				
					case ESC	: 		nRet 	= 0;
										select 	= 0;
										page 	= 0;
										//resut 
										break;
										
							default :	break;					
				}
			}
		}
	return (select + page);
}
